<?

class PageIconFormatter extends ResultsetFormatter
{
 var $d_idColumnName;

 function PageIconFormatter ($idColumnName)
 {
 $this->d_idColumnName = $idColumnName;
 }

 function format( $row )
 {
 return img(get_pageicon(0, $row['code']));
 }
}

class UpFormatter extends ResultsetFormatter {
 function format( $row ){ if ($row['sortorder'] > 0) return i18n('up'); }
}
class DownFormatter extends ResultsetFormatter {
 function format( $row ){ if ($row['sortorder'] > 0 ) return i18n('down'); }
}

GUIFactory::setMainGUI( "main" );

load_menu(11001,$T_NODE,i18n('view languages'), '', 1);


if (!$NODE_ID) {
 $folderInfo = get_folderinfo($FOLDER_ID);
 $NODE_ID = $folderInfo["node_id"];
}

$clearcache = false;

if ($cmd=='switch') {
 $sql = "SELECT * FROM node_contentgroup WHERE contentgroup_id = ".sqlf_tl_num($cg_id)." AND node_id = ".sqlf_tl_num($NODE_ID);
 $rs = query($sql);
 if ($rs['num'] > 0) {
 $switched = 'on';
 $cg_node = $rs["arr"][0]["id"];
 $sql = "SELECT count(*) c FROM page JOIN folder ON page.folder_id=folder.id WHERE folder.node_id=".sqlf_tl_num($NODE_ID)." AND contentgroup_id=".sqlf_tl_num($cg_id);
 $rs = query($sql);
 
 if($rs['arr'][0]['c']==0) {
 $sql = "DELETE FROM node_contentgroup WHERE contentgroup_id = ".sqlf_tl_num($cg_id)." AND node_id = ".sqlf_tl_num($NODE_ID);
 query($sql);

 
 $sql = "SELECT * FROM node_contentgroup WHERE node_id = ".sqlf_tl_num($NODE_ID)." ORDER BY sortorder";
 $rs = query($sql);
 for ($i=0; $i < $rs['num']; $i++) {
 $sql = "UPDATE node_contentgroup SET sortorder=".sqlf_tl_num($i+1)." WHERE contentgroup_id=".sqlf_tl_num($rs['arr'][$i]['contentgroup_id'])." AND node_id = ".sqlf_tl_num($NODE_ID);
 query($sql);
 }
 } else {
 $JS .= "alert('".i18n("cg_unlink_pages_left")."');";
 
 }
 } else {
 $switched = 'off';
 $sql = "SELECT * FROM node_contentgroup WHERE node_id = ".sqlf_tl_num($NODE_ID)." ORDER BY sortorder";
 $rs = query($sql);
 $cg_node = $rs["iid"];
 $sql = "INSERT INTO node_contentgroup (contentgroup_id, node_id, sortorder) VALUES ('".sqlf_escaped($cg_id)."', '".sqlf_escaped($NODE_ID)."', '".sqlf_escaped(++$rs['num'])."')";
 query($sql);
 }

 
 
 
 
 
 triggerEvent(T_NODE, $NODE_ID, EVENT_UPDATE, new EventObject(NULL, array('languages')));

 logcmd($W_EDIT, T_NODE, $NODE_ID, $cg_id, "turned $switched node_contentgroup $cg_id");
 $clearcache = true;
}
if ($cmd == 'up' || $cmd == 'down') {
 
 $sql = "SELECT * FROM node_contentgroup WHERE node_id = ".sqlf_tl_num($NODE_ID)." AND contentgroup_id = ".sqlf_tl_num($cg_id);
 $rs = query($sql);
 $curr = $rs['arr'][0];
 
 $sql = "SELECT contentgroup_id FROM node_contentgroup WHERE node_id = ".sqlf_tl_num($NODE_ID)." ORDER BY sortorder";
 $rs = query($sql);
 if ($cmd == 'up' && $curr['sortorder'] != 1) {
 $sql = "UPDATE node_contentgroup SET sortorder=".sqlf_tl_num($curr['sortorder'])." WHERE sortorder=".sqlf_tl_num($curr['sortorder']-1)." AND node_id = ".sqlf_tl_num($NODE_ID);
 query($sql);
 $sql = "UPDATE node_contentgroup SET sortorder=".sqlf_tl_num($curr['sortorder']-1)." WHERE contentgroup_id=".sqlf_tl_num($cg_id)." AND node_id = ".sqlf_tl_num($NODE_ID);
 query($sql);
 } elseif ($cmd == 'down' && $curr['sortorder'] < $rs['num']) {
 $sql = "UPDATE node_contentgroup SET sortorder=".sqlf_tl_num($curr['sortorder'])." WHERE sortorder=".sqlf_tl_num($curr['sortorder']+1)." AND node_id = ".sqlf_tl_num($NODE_ID);
 query($sql);
 $sql = "UPDATE node_contentgroup SET sortorder=".sqlf_tl_num($curr['sortorder']+1)." WHERE contentgroup_id=".sqlf_tl_num($cg_id)." AND node_id = ".sqlf_tl_num($NODE_ID);
 query($sql);
 }
 $clearcache = true;
}
if($clearcache) {
 
 if ($FEATURE["javaparser"]) {
 node_class('codeparser');
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_NODE, $NODE_ID);
 }
}

$nodeinfo = get_nodeinfo($NODE_ID);
$isMaster = $nodeinfo["master_id"] === "0";


$select = "id, name, code, node_id, sortorder";
$from = "contentgroup LEFT JOIN node_contentgroup ON (node_contentgroup.contentgroup_id = contentgroup.id AND node_id = ".sqlf_tl_num($NODE_ID).")";
$where = '';

$ds = new SQLDatasource( "node_contentgroup", $select, $from, $where );
$ds->setDBHandle( $DB );
$ds->addColumn( "icon", '', false, false, false );
if ($isMaster) {
 
 $ds->addColumn( "lup", '', false, false, false );
 $ds->addColumn( "ldown", '', false, false, false );
}
$ds->addColumn( "sortorder", i18n("sortorder"), false, false, true );
$ds->addColumn( "lactive", i18n("active"), false, false, 'node_id' );
$ds->addColumn( "code", i18n("code"), true, true, true );
$ds->addColumn( "name", i18n("name"), true, true, "name");

$ds->setColumnAttribs('icon','width=25');
$ds->setColumnAttribs('lup','width=80');
$ds->setColumnAttribs('ldown','width=80');
$ds->setColumnAttribs('sortorder','width=25');
$ds->setColumnAttribs('lactive','width=80');
$ds->setColumnAttribs('code','width=80');

$ds->addFormatter( "up", new UpFormatter() );
$ds->addFormatter( "down", new DownFormatter() );
$ds->addFormatter( "active", new BooleanFormatter('node_id') );
$ds->addFormatter( "lactive", new BooleanFormatter('node_id') );
$ds->addFormatter( "icon", new PageIconFormatter('code') );

if ($isMaster) {
 
 $ds->makeLink("lup","up", "do=11013&cmd=up", "list", "cg_id", "id");
 $ds->makeLink("ldown","down", "do=11013&cmd=down", "list", "cg_id", "id");
 $ds->makeLink("lactive","active", "do=11013&cmd=switch", "list", "cg_id", "id");
}

$ds->addSearchableColumn( "name" );
$ds->setDefaultSort("sortorder","ASC");
$ds->setAss("\$name \$code");


$list = new ItemList3("node_contentgroup",$ds);
$list->setShowInfo( true );

?>
