<?

GUIFactory::setMainGUI( "main" );

$translate_edit_do = 14002;



$diff_end = $TIME;


$pageinfo = get_pageinfo( $PAGE_ID );



$NODERELATED[$DO][] = $NODERELATED_PAGE_PREV;

$NODERELATED[$DO][] = $NODERELATED_PAGE_LIVE;
$NODERELATED[$DO][] = $NODERELATED_PAGE_SAVE;
$NODERELATED[$DO][] = $NODERELATED_PAGE_PUB;
$NODERELATED[$DO][] = $NODERELATED_PAGE_PUBNOTIFY;
$NODERELATED[$DO][] = $NODERELATED_PAGE_PUBAT;


$FORCE_DOCTYPE_HTML_4_0 = true;





function getDefaultTranslationPageId(&$o_page) {
 $syncPage = &$o_page->getProperty("sync_page");
 if ($syncPage) {
 return $syncPage->getID();
 }

 $page_id = $o_page->getID();
 $sql = "SELECT dst_page.id AS dst_page_id FROM page AS src_page 
   INNER JOIN folder ON folder.id = src_page.folder_id
   INNER JOIN node_contentgroup ON node_contentgroup.node_id = folder.node_id AND node_contentgroup.contentgroup_id != src_page.contentgroup_id
   INNER JOIN page AS dst_page ON dst_page.contentset_id = src_page.contentset_id AND dst_page.contentgroup_id != src_page.contentgroup_id
   WHERE src_page.id = '".sqlf_escaped($page_id)."' ORDER BY node_contentgroup.sortorder LIMIT 1";

 $rs = query( $sql );
 return $rs['arr'][0]['dst_page_id'];
}




function &getLatestVersionTimestamp( $o_page ) {
 $curr_versions = $o_page->getProperty("versions");
 $keys = $curr_versions->getKeys();
 return $keys[count($keys)-1];
}







function &getDefaultDiffVersions( $originalPage, $translatedPage ) {
 
 
 $syncPage = &$translatedPage->getProperty("sync_page");
 if ($syncPage && $syncPage->getId() == $originalPage->getId()) {
 return array('diff_start' => $translatedPage->getProperty("sync_timestamp"), 'diff_end' => null);
 }

 $editdate = getLatestVersionTimestamp( $translatedPage );
 
 $versions = $originalPage->getProperty("versions");

 $diffversion = null;
 $lastversion = null;
 $vkeys = $versions->getKeys();
 foreach ($vkeys as $key) {
 if( $key <= $editdate || !$diffversion ) {
 $diffversion = $key;
 }
 $lastversion = $key;
 }
 if( $diffversion == $lastversion && count( $vkeys ) > 1 ) {
 $diffversion = $vkeys[count( $vkeys )-2];
 }
 $diff_start = $diffversion;
 $diff_end = $lastversion;
 
 
 if ($diff_start == null) {
 return array( 'diff_start' => $diff_end, 'diff_end' => $diff_end );
 }
 
 $diffversion = $versions->getByKey( $diffversion );
 $diffversion_id = $diffversion->getProperty( 'version' );
 $diffversion_id = $diffversion_id->toString();
 
 $lastversion = $versions->getByKey( $lastversion );
 $lastversion_id = $lastversion->getProperty( 'version' );
 $lastversion_id = $lastversion_id->toString();

 $ret = array( 'diff_start' => $diff_start, 'diff_end' => $diff_end );
 return $ret;
}

function getLatestVersion( &$o_page ) {
 $versions = $o_page->getProperty( 'versions' );
 if( $versions->size() < 1 ) return NULL;
 $version = $versions->get( $versions->size() - 1 );
 return $version->getID();
}


$translatedPage = new CNPageObject( $PAGE_ID );

if( !$diff_page_id )
 $diff_page_id = getDefaultTranslationPageId( $translatedPage );




 $assTitle = $DIC[354] . get_contentgroup_ass($CONTENTGROUP_ID);
 load_menu($pageinfo['editorversion'] == ALOHA ? 14104 : 14004,$T_PAGE,$PAGE_ID,$assTitle,$FORCE_RELOAD, $DO);


$versions = $translatedPage->getProperty( 'versions' );
$cmpPage = $o_page = new CNPageObject($diff_page_id);

if( $cmd != 'advanced' && $versions->size() < 1 && !$page_translate_quick ) {
 $DO_TRANSLATE = true;
 $start_info = $end_info = NULL;
 unset($diff_end);
 generateAssistantAndLabel( $o_page, $start_info, $end_info );
 return;
}

function checkLocked( $page_id ) {
 global $JS, $diff_start, $diff_end, $JS_ONUNLOAD;

 if(is_locked( $page_id, 'page', false ) && $diff_start && $diff_end) {
 $JS .= "alert('".i18n('page_translate_islocked')."');";
 unset( $diff_start ); unset( $diff_end );
 return true;
 } else {
 
 return false;
 }
}

function doCancel( &$form ) {
 global $REDO;
 $REDO = 13011;
}


if( $page_translate_quick ) {
 $DO_TRANSLATE = true;
 
 
 
 
 
 $defaultVersions = getDefaultDiffVersions( $o_page, $translatedPage );
 $diff_start = $defaultVersions['diff_start'];
 $diff_end = $defaultVersions['diff_end'];

 $translationPage = new CNPageObject($diff_page_id);
 $start_info = getVersionInformation( $translationPage, $diff_start );
 if( $diff_start == $diff_end || checkLocked( $diff_page_id ) ) {
 $end_info = NULL;
 unset( $diff_end );
 } else {
 $end_info = getVersionInformation( $translationPage, $diff_end );
 }
 
 generateAssistantAndLabel( $translationPage, $start_info, $end_info );

 return;
}

if( $cmd == 'cmp' ) {
 $diff_end = 0;
 $DO_TRANSLATE = true;

 $translationPage = new CNPageObject($diff_page_id);
 $diff_end = getLatestVersion( $translationPage );
 $start_info = getVersionInformation( $translationPage, $diff_start );
 if( $diff_start == $diff_end || checkLocked( $diff_page_id ) ) {
 $end_info = NULL;
 unset($diff_end);
 } else
 $end_info = getVersionInformation( $translationPage, $diff_end );
 
 generateAssistantAndLabel( $translationPage, $start_info, $end_info );

 return;
}


























function &getVersionInformation($o_page, $version_timestamp) {
 if( !$version_timestamp ) return NULL;
 $versions = $o_page->getProperty( 'versions' );
 if( !$versions->keyExists( $version_timestamp ) ) return NULL;
 $version = $versions->getByKey( $version_timestamp );

 $ret = array( );

 $version_id = $version->getProperty( 'version' );
 $version_id = $version_id->toString();

 $tstmp = resolveProperty("date.timestamp", $version);
 
 $user = $version->getProperty( 'user' );
 $user = $user->getProperty('name');

 $ret['version_id'] = $version_id;
 $ret['date'] = db2date($tstmp->toString());
 $ret['user_fullname'] = $user->toString();

 return $ret;
}






function doTranslate( &$form) {
 global $diff_start, $diff_end, $diff_page_id, $DO_TRANSLATE, $ASSCORE;
 $listcomp =& $form->resolveComponent( 'main.somelist' );
 $list =& $listcomp->getList();

 $sel = $list->getSelection();
 if( count($sel) > 0 ) {
 $DO_TRANSLATE = true;
 list( $diff_page_id, $diff_start ) = explode('_',$sel[0]);
 list( $nada, $diff_end ) = explode('_',$sel[1]);
 if( !$diff_end ) $diff_end = $diff_start;

 $translationPage = new CNPageObject($diff_page_id);
 $start_info = getVersionInformation( $translationPage, $diff_start );
 $end_info = getVersionInformation( $translationPage, $diff_end );

 generateAssistantAndLabel( $translationpage, $start_info, $end_info );
 }
}

function generateAssistantAndLabel($translationPage, &$start_info, &$end_info) {
 global $ASSCORE, $page_translate_label, $NODERELATED, $DO, $STAG, $cmpPage;

 $cmpPage = $translationPage;

 $name = $translationPage->getProperty( 'name' ); $name = $name->toString();
 $code = $translationPage->getProperty( 'code' ); $code = $code->toString();
 

 $related['link'] = "javascript:go_list('$STAG&do=$DO&cmd=advanced');";
 $related['text'] = i18n( 'Compare Languages' );
 $related['target'] = 'list';
 
 $NODERELATED[$DO][] = $related;

 $ASSCORE = i18n("page_translate_compare_site").": $name ($code)<br/><br/>";
 if( $start_info != NULL ) {
 if( $end_info !== NULL )
 $ASSCORE .= i18n("versiondiff_between")."<br/>";
 $ASSCORE .= i18n("version")." ${start_info['version_id']}<br/>&nbsp;&nbsp;${start_info['date']} (${start_info['user_fullname']})<br/>";
 if( $end_info !== NULL )
 $ASSCORE .= "<br/>".i18n("version")." ${end_info['version_id']}<br/>&nbsp;&nbsp;${end_info['date']} (${end_info['user_fullname']})";
 }
}








function &createVersionTableData($originalPage) {
 global $PAGE_ID, $STAG, $DO;

 $diff_page_id = $originalPage->getID();


 $sql = "SELECT translations_page.contentgroup_id, translations_page.id AS page_id,translations_page.name FROM page AS src_page 
  INNER JOIN page AS translations_page ON translations_page.contentset_id = src_page.contentset_id
  INNER JOIN folder ON src_page.folder_id = folder.id 
  INNER JOIN node_contentgroup ON node_contentgroup.node_id = folder.node_id AND translations_page.contentgroup_id = node_contentgroup.contentgroup_id
  WHERE src_page.id = ".sqlf_tl_num($PAGE_ID);
 $rs = query( $sql );
 $folderinfo = get_folderinfo( $pageinfo['folder_id'] );
 $contentgroups = get_contentgroups( $folderinfo['node_id'] );
 $langs = array( );
 $originals = array( );
 $translation = null;
 foreach( $rs['arr'] as $row ) {
 $cg = $contentgroups[$row['contentgroup_id']];
 $langs[$row['page_id']] = $cg['name'] . ' (' . $cg['code'] . '): ' . $row['name'];
 if( $row['page_id'] == $PAGE_ID ) $translation = $cg;
 else $originals[] = $row['page_id'];
 }

 $headers = array();
 $headers['date'] = i18n( 'Date' );
 $headers['original'] = i18n( 'Languages' );
 $headers['translation'] = i18n( 'Current Language' ) . ' (' . $translation['code'] . ')';
 $headers['user'] = i18n( 'User' );
 $headers['published'] = i18n( 'Status' );





 $data = array();

 
 $translationPage = new CNPageObject($PAGE_ID);

 
 $translationVersions = $translationPage->getProperty( 'versions' );

 
 if( $translationVersions->size() > 0 ) {
 $firstVersion = $translationVersions->get(0);
 $firstVersionTimestamp = $firstVersion->getID();
 }

 $allVersions = array( );
 
 
 $allVersions = nodeHashToArray($translationVersions, $allVersions);

 
 $originalPages = array( );
 foreach( $originals as $original ) {
 $originalPages[] = $op = new CNPageObject( $original );
 $myVersions = $op->getProperty( 'versions' );
 
 $allVersions = nodeHashToArray($myVersions, $allVersions, NULL);
 }


 $disabledRows = array( );
 $selectedRows = array( );

 $lastVersionNumbers = array( );

 global $PAGE_STATUS_LANG_ICON;
 $base = $PAGE_STATUS_LANG_ICON[1];
 foreach( $allVersions as $key => $val ) {
 $m = $val->getProperty( 'mother' );
 $d = array();
 $d['type'] = i18n( 'Highlight changes since ...' );
 $v = $val->getProperty( 'version' );
 $vdate = resolveProperty("date.timestamp", $val);
 $tstmp = $vdate->toString();
 $vdate = db2date($vdate->toString());


 $user = $val->getProperty( 'user' );
 $user = $user->getProperty('name');
 $d['user'] = $user->toString();
 $d['date'] = $vdate;
 $str = $v->toString();
 $d['id'] = $m->getID() . '_' . $val->getID();
 list($major, $minor) = explode('.', $str);
 $lasttstmp = $lastVersionNumbers[$m->getID()]['lastversion'];
 if( !$lasttstmp ) {
 $lasttstmp = $tstmp;
 }
 $lastVersionNumbers[$m->getID()]['lastversion'] = $tstmp;
 if( $m->getID() != $translationPage->getID() ) {
 if(!$FEATURE['translate_showallversions'] && $tstmp < $firstVersionTimestamp) continue;
 
 $str = '';
 foreach( $contentgroups as $key => $val ) {
 $cg = $m->getFieldValue("contentgroup_id");
 if( $cg == $key ) {
 
 $str .= "<a href='$STAG&do=$DO&cmd=cmp&diff_page_id=".$m->getID()."&diff_start=$lasttstmp'>";
 $str .= img( get_langicon( $base, $contentgroups[$cg]["code"], "content" ), 0, $val['name'] ) . "</a>&nbsp;";
 } else {
 $str .= img( "", 0, "", "", 18 ) . "&nbsp;";
 }
 }
 $d['original'] = $str;
 
 if( $defaultDiffVersions['diff_start'] == $tstmp || $defaultDiffVersions['diff_end'] == $tstmp ) {
 $selectedRows[$d['id']] = true;
 }
 } else {
 
 $val = $contentgroups[$m->getFieldValue("contentgroup_id")];
 $d['translation'] = img( get_langicon( $base, $val['code'], "content" ), 0, $val['name'], '', '', '', '', '', 'gentics_icon_invisible' );
 $disabledRows[$d['id']] = true;
 }

 if( $lastVersionNumbers[$m->getID()]['major'] != $major ) {
 $lastVersionNumbers[$m->getID()]['major'] = $major;
 if( $major > 0 ) {
 $d['published'] = i18n( 'Published' );
 }
 }


 $data[] = $d;
 }

 $d = array( );
 $d['id'] = 'current';
 $d['date'] = i18n( 'Current' );
 $d['user'] = i18n( 'N/A' );
 $d['type'] = i18n( 'Current Version' );
 $str = '';
 foreach( $contentgroups as $key => $val ) {
 $originalPage = NULL;
 foreach( $originalPages as $op ) {
 $cg = $op->getFieldValue("contentgroup_id");
 if( $cg == $key ) {
 $originalPage = $op;
 break;
 }
 }
 if( $originalPage !== NULL ) {
 $str .= "<a href='$STAG&do=$DO&cmd=cmp&diff_page_id=".$originalPage->getID()."'>";
 $str .= img( get_langicon( $base, $val["code"], "content" ), 0, $val['name'] ) . "</a>&nbsp;";
 } else {
 $str .= img( "", 0, "", "", 18 ) . "&nbsp;";
 }
 }
 $d['original'] = $str;
 $data[] = $d;

 return array( 'langs' => $langs, 'headers' => $headers, 'data' => $data, 'disabledRows' => $disabledRows, 'selectedRows' => $selectedRows );
}


$ASSCORE = i18n( 'cn_page_translate_description' );

if(true) {
 $form = new HtmlForm3("page_translate");

 if ($form->isNew()) {
 node_class( 'selectcomponent' );
 node_class( 'arraydatasource' );
 node_class( 'itemlistcomponent' );
 node_class( 'labelcomponent' );
 
 $main = new ListComponent();

 $tableData = createVersionTableData( $o_page );

 $ds = new ArrayDatasource($tableData['data'], $tableData['headers'] );
 $ds->setCheckboxDisabled($tableData['disabledRows']);
 $ds->setPreSelected( $tableData['selectedRows'] );

 

 $list = new ItemList3("objprop_new", $ds );
 $list->setGroupableColumns( array( 'type' ) );
 $list->setNextSortWay( 'type' );
 $main->setComponent('somelist', new ItemListComponent( i18n( 'Versions' ), $list ) );
 
 global $PAGE_STATUS_LANG_ICON;
 $contentGroups = get_contentgroups();
 $img = get_langicon( $PAGE_STATUS_LANG_ICON[1], $pageinfo['code'], "content" );
 $form->setHeader( img( $img, 0 ) . '&nbsp;' . $contentGroups[$pageinfo['contentgroup_id']]['name'] . ' ' . i18n( 'compare with' ). ':', $img );
 $form->addComponent( 'main', $main );
 
 $form->addButton( 'cancel', new Button( i18n( 'Cancel' ) ), new SimpleFormAction('doCancel') );
 }
}





function &nodeHashToArray( &$nodeHash, &$array, $firstVersionTimestamp = NULL ) {
 $it = $nodeHash->iterator();
 $i = 0;
 $arr = array( );
 while( $it->hasNext() ) {
 $myval = $it->next();
 $date = $myval->getProperty('date');
 $tstmp = $date->getTimestamp();
 if( $firstVersionTimestamp !== NULL && $tstmp < $firstVersionTimestamp ) continue;
 while($i < count( $array )) {
 $item = $array[$i];
 $cmpdate = $item->getProperty('date');
 $cmptstmp = $cmpdate->getTimestamp();
 if( $tstmp < $cmptstmp )
 break;
 $i++;
 $arr[] = $item;
 }
 $arr[] = $myval;
 }
 while( $i < count( $array ) ) {
 $arr[] = $array[$i++];
 }
 return $arr;
}









?>