<?php

$maingui = &GUIFactory::setMainGUI("main");
$maingui->includeJS("jquery");
$maingui->includeJS("jquery.autocomplete.min");

node_class("htmlform3");
node_class("contentrepository");

mysession_var_reg("CR_ID");
mysession_var_reg("CNMAP_EDIT_ARG_ID");

$JS .= "
\$().ready(function() {
  \$(\"#category\").autocomplete(\"$STAG&do=15218&cr_id=$CR_ID\", {matchCase:true});
});
";


if ($_GET["id"]) {
 $CNMAP_EDIT_ARG_ID = $_GET["id"];
 $sql = "SELECT * FROM tagmap WHERE id = " . intval($id);
 $rs = query($sql);
 $v = $rs["arr"][0];
 $tagname = $v["tagname"];
 $mapname = $v["mapname"];
 $object = $v["object"];
 $attributetype = $v["attributetype"];
 $category = $v["category"];
 $multivalue = $v["multivalue"];
 $optimized = $v["optimized"];
 $foreignlinkattribute = $v["foreignlinkattribute"];
 $foreignlinkattributerule = $v["foreignlinkattributerule"];
 $objtype = $v["objtype"];
 $static = $v["static"];
 $editable = perm($USER_ID, T_CONTENTREPOSITORY, $v["contentrepository_id"], 2);
} else {
 $editable = perm($USER_ID, T_CONTENTREPOSITORY, $CR_ID, 2);
}

$form = new HtmlForm3("tagmapentry");




function saveTagmapEntry( &$form, $param ) {
 global $CNMAP_EDIT_ARG_ID, $contentmap, $tagmapTable, $tagmapTableRow, $JS, $STAG, $static, $mapname, $object, $DB, $CR_ID;
 
 $ftagname =& $form->resolveComponent( "tagname" );
 $fmapname =& $form->resolveComponent( "mapname" );
 $fobject =& $form->resolveComponent( "object" );
 $fobjtype =& $form->resolveComponent( "objtype" );
 $fattributetype =& $form->resolveComponent( "attributetype" );
 $fmultivalue =& $form->resolveComponent( "multivalue" );
 $foptimized =& $form->resolveComponent( "optimized" );
 $fforeignlinkattribute =& $form->resolveComponent( "foreignlinkattribute" );
 $fforeignlinkattributerule =& $form->resolveComponent( "foreignlinkattributerule" );
 $fcategory =& $form->resolveComponent("category");

 if( $foptimized->isChecked() && $fmultivalue->isChecked() ) {
 $foptimized->addError( new NodeException( i18n( "A Multivalue Tagmap Entry cannot be Optimized." ) ) );
 return;
 }
 $sql = "SELECT * FROM tagmap
	WHERE mapname = '".sqlslashes( $fmapname->getText() )."'
		AND attributetype != '" . sqlf_escaped($fattributetype->getSingleSelection()) . "'
		AND object != '" . sqlslashes($fobject->getSingleSelection()) . "' 
		AND contentrepository_id = " . sqlf_tl_num($CR_ID);
 $rs = query( $sql );
 if( count($rs["arr"]) > 0 ) {
 $fmapname->addError( new NodeException( i18n("Tagmap entry with mapname \"{0}\" and attributetype {1} conflicts with entry with tagname \"{2}\" and attributetype {3}. (Attributetype of all Entries with the same mapname needs to be the identical.)",0, array( $fmapname->getText(), $fattributetype->getSingleSelection(), $rs["arr"][0]["tagname"], $rs["arr"][0]["attributetype"] ) ) ) );
 return;
 }

 
 $sql = "SELECT * FROM tagmap
	WHERE mapname = '".sqlslashes( $fmapname->getText() )."'
		AND object = '" . sqlslashes($fobject->getSingleSelection()) . "' 
		AND contentrepository_id = " . sqlf_tl_num($CR_ID);
 if ( $CNMAP_EDIT_ARG_ID != "new" ) {
 $sql .= " AND id != '".sqlslashes($CNMAP_EDIT_ARG_ID)."'";
 }
 $rs = query( $sql );
 if( count($rs["arr"]) > 0 ) {
 $fmapname->addError( new NodeException( i18n("duplicate_tagmap_entry") ) ) ;
 return;
 } 

 if( $static ) {
 $sql = "UPDATE tagmap SET optimized = '" . sqlf_escaped($foptimized->getSingleSelection()) . "' WHERE mapname = '" . sqlslashes( $mapname ) . "' AND object = '" . sqlslashes($object) . "' AND contentrepository_id = ".sqlf_tl_num($CR_ID);
 query( $sql );
 } else if( $CNMAP_EDIT_ARG_ID == "new" ) {
 $sql = "INSERT INTO tagmap (tagname,mapname,object,objtype,attributetype,multivalue,static,optimized,foreignlinkattribute,foreignlinkattributerule,contentrepository_id,category) values " .
 "('" . sqlslashes( $ftagname->getText() ) . "','" .
 sqlslashes( $fmapname->getText() ) . "','" .
 sqlslashes( $fobject->getSingleSelection() ) . "','" .
 sqlslashes( $fobjtype->getSingleSelection() ) . "','" .
 sqlslashes( $fattributetype->getSingleSelection() ) . "','" .
 ($fmultivalue->isChecked() ? 1 : 0) . "',0,'" .
 ($foptimized->isChecked() ? 1 : 0) . "','" .
 sqlslashes($fforeignlinkattribute->getText()) . "','".
 sqlslashes($fforeignlinkattributerule->getText())."','" .
 sqlf_escaped($CR_ID) . "','".sqlslashes($fcategory->getText())."')";
 query( $sql );
 } else {
 $sql = "UPDATE tagmap SET tagname = '" .
 sqlslashes( $ftagname->getText() ) . "', mapname = '" .
 sqlslashes( $fmapname->getText() ) . "', object = '" .
 sqlslashes( $fobject->getSingleSelection() ) . "', objtype = '" .
 sqlslashes( $fobjtype->getSingleSelection() ) . "', attributetype = '" .
 sqlslashes( $fattributetype->getSingleSelection() ) . "', multivalue = '" .
 ($fmultivalue->isChecked() ? 1 : 0) . "', optimized = '" .
 ($foptimized->isChecked() ? 1 : 0) . "', foreignlinkattribute = '" .
 sqlslashes($fforeignlinkattribute->getText()) . "', foreignlinkattributerule = '".
 sqlslashes($fforeignlinkattributerule->getText())."', contentrepository_id = '" .
 sqlf_escaped($CR_ID) . "', category = '".sqlslashes($fcategory->getText())."'";
 $sql .= " WHERE id = '".sqlslashes($CNMAP_EDIT_ARG_ID)."'";
 query( $sql );
 }
 $sql = "UPDATE tagmap SET optimized = '" . sqlf_escaped($foptimized->getSingleSelection()) . "' WHERE mapname = '" . sqlslashes( $fmapname->getText() ) . "' AND contentrepository_id = ".sqlf_tl_num($CR_ID);
 query( $sql );




 
 $JS .= "document.location.href='$STAG&do=15200&STATUS=" . 
 urlencode(i18n( "Tagmap Entry Saved. Changes will only apply when objects are (re)published." )) . "';";
}




function changedAttributetype( &$form, $param ) {
 $fattributetype =& $form->resolveComponent( "attributetype" );
 $fforeignlinkattribute =& $form->resolveComponent( "foreignlinkattribute" );
 $fforeignlinkattribute->setVisible( $fattributetype->getSingleSelection() == 7 );
 $fforeignlinkattributerule =& $form->resolveComponent( "foreignlinkattributerule" );
 $fforeignlinkattributerule->setVisible( $fattributetype->getSingleSelection() == 7 );
 $fobjtype =& $form->resolveComponent( "objtype" );
 $fobjtype->setVisible( $fattributetype->getSingleSelection() == 2 || $fattributetype->getSingleSelection() == 7 );
 $fobjtype->setOptional( !($fattributetype->getSingleSelection() == 2 || $fattributetype->getSingleSelection() == 7) );
}

if ($form->isNew()) {
 node_include("icons");
 node_class("selectcomponent");
 node_class("textcomponent");
 node_class("checkboxcomponent");
 node_class("labelcomponent");


 $form->setHeader( i18n( "Edit Tagmap Entry" ), $ICO_CONTENTMAP_TAGMAP  );







 
 $form->addComponent( "mapname", $fmapname = new TextComponent( i18n( "mapname" ), true, $mapname, REG_TEXT_SHORT ) );
 $fmapname->setEditable( !$static && $editable );
 $fmapname->setDisabled( $static || !$editable );
 $fmapname->setHelp( i18n( "Enter the attribute name for this entry under which it will be known in the Gentics Content Repository." ) );
 $form->addComponent( "tagname", $ftagname = new TextComponent( i18n( "tagname" ), true, $tagname ) );
 $ftagname->setEditable( !$static && $editable );
 $ftagname->setDisabled( $static || !$editable );
 $ftagname->setHelp( i18n( "Enter the tagmap name for this entry. (The Tag name in Gentics Content.Node e.g. object.myobjprop)" ) );
 
 $objTypes = array( "10002" => "[10002] Folder",
 "10007" => "[10007] Page",
 "10008" => "[10008] File" );
 $form->addComponent( "object", $fobject = new SelectComponent( i18n( "object" ), $objTypes, $object ) );
 $fobject->setEditable( !$static && $editable );
 $fobject->setHelp( i18n( "Enter the Object Type this Tagmap entry applies to." ) );
 
 $form->addComponent( "attributetype", $fattributetype = new SelectComponent( i18n( "attributetype" ),
 array( "1" => "[1] Text (short)",
 "2" => "[2] Object Link",
 "3" => "[3] Integer",
 "5" => "[5] Text (long)",
 "6" => "[6] Binary",
 "7" => "[7] Foreign Link"), $attributetype )
 );
 $fattributetype->setHelp( i18n( "Choose the Type for the attribute in the Gentics Content Repository." ) );
 $fattributetype->setOnChangeAction ( new SimpleFormAction( "changedAttributetype" ) );
 $fattributetype->setEditable( !$static && $editable );

 $form->addComponent("category", $fcategory = new TextComponent(i18n("category"), true, $category, REG_TEXT, 20, FALSE, "category"));
 $fcategory->setEditable($editable);
 $fcategory->setDisabled(!$editable);

 $form->addComponent( "multivalue", $fmultivalue = new CheckboxComponent( i18n("Multivalue"), $multivalue ) );
 $fmultivalue->setEditable( !$static && $editable );
 $fmultivalue->setHelp( i18n( "Choose if this attribute can contain multiple values." ) );
 
 $form->addComponent( "optimized", $foptimized = new CheckboxComponent( i18n("Optimized"), $optimized ) );
 $foptimized->setEditable( $editable );
 $foptimized->setHelp( i18n( "Activate optimized if many operations depend on this Attribute - But be careful, activating this option will increase the size of the database and may even slow down overall performance if not used carefully (It should also be noted that the next publish run might run significantly longer than usual)." ) );
 
 $form->addComponent( "objtype", $fobjtype = new SelectComponent( i18n( "Linked Object Type" ), $objTypes, $objtype ) );
 $fobjtype->setEditable( !$static && $editable );
 $fobjtype->setHelp( i18n( "Choose the linked object type." ) );
 $fobjtype->setVisible( $attributetype == 2 || $attributetype == 7);
 $fobjtype->setOptional( !($attributetype == 2 || $attributetype == 7) );
 
 $form->addComponent( "foreignlinkattribute", $fforeignlinkattribute = new TextComponent( i18n( "Foreignlink Attribute" ), true, $foreignlinkattribute ) );
 $fforeignlinkattribute->setHelp( i18n( "Enter the name of the Link Attribute of the Linked Object Type which references to this Object Type." ) );
 $fforeignlinkattribute->setVisible( $attributetype == 7 );
 $fforeignlinkattribute->setEditable( !$static && $editable );
 
 $form->addComponent( "foreignlinkattributerule", $fforeignlinkattributerule = new TextAreaComponent( i18n("Foreignlink Attribute Rule"), true, $foreignlinkattributerule ) );
 $fforeignlinkattributerule->setHelp( i18n( "foreignlinkattributerule_help" ));
 $fforeignlinkattributerule->setVisible( $attributetype == 7 );
 $fforeignlinkattributerule->setEditable( !$static && $editable );
 
 $form->addComponent( "status", $ftextcomponent = new LabelComponent( i18n( "Status" ), "", true ) );
 $ftextcomponent->setVisible( false );
 
 if ($editable) {
 $form->addButton( "save", new Button( i18n( "Save" ) ), new SimpleFormAction( "saveTagmapEntry" ), true );
 }
 $form->addButton( "cancel", new Button( i18n( "Cancel" ), false ), new RedoFormAction(15200), true );
}
?>