<?



mysession_var_reg("CONTENTGROUP_ID");







function get_pages($folder_id = 0, $contentgroup_id = 0, $contentgroup_link = "", $folders = array(), $search = '', $ires = array(), $search_contents = false, $start = 0, $count = 0) {

 global $FOLDER_ID, $FEATURE, $SQLAS, $CONTENTGROUP_ID, $NODE_ID;

 
 
 global $SHOW_ALL_CONTENTGROUPS;

 
 if ( $folders !== false && !$folder_id && !$FOLDER_ID && (!is_array($folders) || count($folders) == 0) ) {
 warning(7,'cn:get_pages: No Folder id and no array of Folder ids');
 return array();
 }

 
 if ( is_array($folders) && count($folders) > 0) {
 $folder = "AND page.folder_id IN (".implode(",",sqlf_tl_num_array($folders)).")";
 } else if ( $folders !== false ) {
 if (!$folder_id) {
 $folder_id = $FOLDER_ID;
 }
 $folder = "AND page.folder_id = ".sqlf_tl_num($folder_id);
 } else {
 $folder = "";
 }
 
 
 if ($FEATURE["contentgroup3"]) {
 $group_contentset = "GROUP BY page.contentset_id, cpage.id";
 
 $cg = $SHOW_ALL_CONTENTGROUPS ? get_all_contentgroups() : get_contentgroups($NODE_ID);
 if (!$contentgroup_id || !$cg[$contentgroup_id]) {
 if (!$CONTENTGROUP_ID || !$cg[$CONTENTGROUP_ID]) {
 $CONTENTGROUP_ID = key($cg);
 }
 $contentgroup_id = $CONTENTGROUP_ID;
 }
 
 
 if ( $contentgroup_id ) 
 $where_contentgroup = "AND contentgroup.id=".sqlf_tl_num($contentgroup_id);

 
 $join_cpage = "LEFT JOIN page $SQLAS cpage ON (page.id = cpage.id AND cpage.contentset_id = 0)";
 }

 
 if ($search_contents && $FEATURE["search_contents"]) {
 $search_contents_sql_join = ' LEFT JOIN contenttag ON page.content_id = contenttag.content_id LEFT JOIN value ON contenttag.id = value.contenttag_id ';
 }

 $sql_select = "page.id, page.status, page.priority, page.filename, page.name, page.description, page.folder_id, 
	page.contentgroup_id, page.contentset_id, page.cdate AS pcdate, page.edate AS pedate, page.template_id, page.content_id, page.time_pub,
	content.locked, content.locked_by, 
	template.name AS tname, 
	folder.name AS folder, folder.id AS folderid, 
	contentgroup.code, contentgroup.id AS cgid, 
	peuser.firstname AS pe_firstname, peuser.lastname AS pe_lastname, 
	pcuser.firstname AS pc_firstname, pcuser.lastname AS pc_lastname
	".$ires["select"]." ";
 $sql_from = "$search_contents_sql_from template, systemuser $SQLAS pcuser, systemuser $SQLAS peuser, content, page LEFT JOIN folder ON (page.folder_id = folder.id)";
 $sql_where = "page.channel_id = 0 AND template.id = page.template_id AND pcuser.id = page.creator AND peuser.id = page.editor AND folder.id IS NOT NULL AND page.content_id = content.id $search_contents_sql_where"; 

 $sql_cg_join = "LEFT JOIN contentgroup ON (contentgroup.id = page.contentgroup_id $where_contentgroup) $join_cpage";

 $completesqlwhere = "$sql_where $folder $search";
 $sql1 = "SELECT $sql_select FROM $sql_from $sql_cg_join $search_contents_sql_join WHERE $completesqlwhere $group_contentset ".$ires["orderby"];
 if( $start || $count ) {
 $sql1 .= " LIMIT ".sqlf_limit_num($start).", ".sqlf_limit_num($count)." ";
 }

 $rs = query($sql1);
 $ret = array();
 if ($FEATURE["contentgroup3"] ) {
 $contentGroups = $SHOW_ALL_CONTENTGROUPS ? get_all_contentgroups() : get_contentgroups();
 if (is_array($rs["arr"])) {
 while (list($key,$val) = each($rs["arr"])) {
 $lang = array();
 
 
 if ($val['contentset_id']) {
 
 $sql2 = "SELECT $sql_select FROM contentgroup, $sql_from
					LEFT JOIN node_contentgroup ON (node_contentgroup.contentgroup_id = page.contentgroup_id AND node_contentgroup.node_id = folder.node_id)
					WHERE $sql_where AND contentgroup.id = page.contentgroup_id AND page.contentset_id = ".sqlf_tl_num($val["contentset_id"]).
 ' GROUP BY page.contentgroup_id ORDER BY node_contentgroup.sortorder';
 $rs1 = query($sql2);
 foreach ($rs1['arr'] as $key1=>$val1) {
 if ($val1['contentgroup_id'] == $contentgroup_id || !$val["cgid"]) {
 $val = $val1;
 }
 $lang[$val1["contentgroup_id"]] = $val1;
 }
 }
 $val['lang'] = $lang;
 
 
 if (is_array($val['lang'])) {
 $lang_link = '';
 foreach ( $contentGroups as $cgKey => $cgVal )
 {
 if ( isset( $val['lang'][$cgKey] ) )
 {
 $lang_page = $val['lang'][$cgKey];
 $link = str_replace(
 array('$folder_id', '$contentgroup_id', '$page_id'),
 array($lang_page['folder_id'], $cgKey, $lang_page['id']),
 $contentgroup_link);
 $lang_link .= '<a href="'.$link.'">' .
 img(get_pageicon($lang_page['status'], $lang_page['code'], $lang_page['inherited']), 0, $cgVal['name']).'</a>&nbsp;';
 }
 else
 $lang_link .= img( "", 0, "", "", 18 ) . "&nbsp;";
 }
 $val['lang_link'] = $lang_link;
 }

 $ret[] = $val;
 }
 }
 } else {
 $ret = $rs['arr'];
 }
 if( $start || $count ) {
 
 if( count( $ret ) == $count || count( $ret ) == 0 ) {
 
 
 $sql2 = "SELECT page.id as count FROM $sql_from $sql_cg_join $search_contents_sql_join WHERE $completesqlwhere $group_contentset";
 $rs = query( $sql2 );
 $totalcount = $rs['num'];
 if( $start > $totalcount ) {
 
 return NULL;
 }
 if( $start > 0 ) {
 $ret2 = array_fill(0, $start, NULL);
 $ret = array_merge( $ret2, $ret );
 }
 if( $totalcount > $start + $count ) {
 $ret = array_merge( $ret, array_fill(0, $totalcount - $start - $count, NULL) );
 }
 } else {
 if( $start > 0 ) {
 $ret2 = array_fill(0, $start, NULL);
 $ret = array_merge( $ret2, $ret );
 }
 }
 }
 return $ret;
 
}













function getPagesFromREST($folder_id = 0, $contentgroup_id = 0, $cg_link = "", $search = null,
 $ires = array(), $km = null, $start = 0, $count = -1, $usageinfo_type = false, $usageinfo_objs = false) {
 global $CN_LOCAL_SERVER, $CONTENTGROUPS, $SESSION_TOKEN, $NODE_ID, $FEATURE, $T_PAGE, $T_IMAGE, $T_FILE;

 if ( $FEATURE["contentgroup3"] ) {
 $contentGroups = get_contentgroups();
 }

 
 $fc = new fetchCurl();
 $searchurl = "";

 
 if ($usageinfo_type == $T_PAGE && is_array($usageinfo_objs)) {
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/page/usage/variant";
 reset($usageinfo_objs);
 while (list($key, $val) = each($usageinfo_objs)) {
 $searchurl .= "&id=".urlencode($val);
 }
 } else if ($usageinfo_type == "$T_PAGE"."_PAGETAGS" && is_array($usageinfo_objs)) {
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/page/usage/tag";
 reset($usageinfo_objs);
 while (list($key, $val) = each($usageinfo_objs)) {
 $searchurl .= "&id=".urlencode($val);
 }
 } else if ($usageinfo_type == $T_IMAGE && is_array($usageinfo_objs)) {
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/image/usage/page";
 reset($usageinfo_objs);
 while (list($key, $val) = each($usageinfo_objs)) {
 $searchurl .= "&id=".urlencode($val);
 }
 } else if ($usageinfo_type == $T_FILE && is_array($usageinfo_objs)) {
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/file/usage/page";
 reset($usageinfo_objs);
 while (list($key, $val) = each($usageinfo_objs)) {
 $searchurl .= "&id=".urlencode($val);
 }
 } else {
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/folder/getPages/$folder_id";
 }

 $language_set = false;
 if (is_string($search)) {
 
 $searchurl .= "&search=".urlencode($search)."&recursive=true";
 } else if (is_array($search)) {
 
 reset($search);
 while (list($key, $val) = each($search)) {
 if ($key == "language") {
 $searchurl .= "&language=".urlencode($val)."&langfallback=false";
 $language_set = true;
 } else {
 if (is_array($val)) {
 reset($val);
 while (list($k, $v) = each($val)) {
 $searchurl .= "&$key=".urlencode($v);
 }
 } else {
 $searchurl .= "&$key=".urlencode($val);
 }
 }
 }
 }
 if ($contentgroup_id && !$language_set) {
 load_contentgroups();
 $langurl = "&language=".$CONTENTGROUPS[$contentgroup_id]["code"];
 }
 $url .= "?sid=$SESSION_TOKEN&nodeId=$NODE_ID&template=true$langurl$searchurl&langvars=true&sortby={$ires['field']}&sortorder={$ires['way']}&skipCount=$start&maxItems=$count";
 $fc->setUrl($url);

 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $pages = json_decode($json,true);
 $total = $pages["numItems"];
 $pages = $pages["pages"];

 
 if ($km) {
 $pages = $km->remap($pages);
 }

 
 reset($pages);
 while (list($key, $val) = each($pages)) {
 if (is_array($val['lang'])) {
 $lang_link = '';
 foreach ( $contentGroups as $cgKey => $cgVal ) {
 if ( isset( $val['lang'][$cgKey] ) ) {
 $lang_page = $val['lang'][$cgKey];
 $link = str_replace(
 array('$folder_id', '$contentgroup_id', '$page_id'),
 array($lang_page['folder_id'], $cgKey, $lang_page['id']),
 $cg_link);
 $lang_link .= '<a href="'.$link.'">' .
 img(get_pageicon($lang_page['status'], $lang_page['language'], $lang_page["inherited"]), 0, $cgVal['name']).'</a>&nbsp;';
 } else {
 $lang_link .= img( "", 0, "", "", 18 ) . "&nbsp;";
 }
 }
 $pages[$key]['lang_link'] = $lang_link;
 }
 }
 reset($pages);

 
 if ($start > 0) {
 $pages = array_pad($pages, -count($pages) - $start, null);
 }
 if ($total > count($pages)) {
 $pages = array_pad($pages, $total, null);
 }

 return $pages;
}

?>
