<?

function page_status($page_id, $status, $user_id = "", $isNotification=false, $noUserMessage = false) {
 if (!$page_id) halt(7,"page_status: invalid page_id($page_id)");
 global $USER_ID,$TIME,$W_EDIT, $W_DEL, $T_PAGE, $NAMECHANGE, $FEATURE, $W_PAGEPUB, $W_PAGETIME, $W_PAGEQUEUE, $T_FOLDER, $DEBUG;

 $NAMECHANGE = true;
 $sql = "SELECT page.publisher,"
 . " page.name,"
 . " page.folder_id,"
 . " page.status,"
 . " page.pdate,"
 . " page.time_pub,"
 . " page.editor,"
 . " publish.active"
 . " FROM page"
 . " LEFT JOIN publish"
 . " ON page.id = publish.page_id"
 . " AND publish.active > 0"
 . " WHERE page.id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 $old_status = $rs["arr"][0]["status"];
 $old_pdate = $rs["arr"][0]["pdate"];
 $time_pub = $rs["arr"][0]["time_pub"];
 $folder_id = $rs["arr"][0]["folder_id"];
 $publisher = $rs["arr"][0]["publisher"];
 $editor = $rs["arr"][0]["editor"];
 $active = $rs["arr"][0]["active"]?1:0;
 $name = $rs["arr"][0]["name"];
 $folderinfo = get_folderinfo($folder_id);

 decho( "page_status: id: ($page_id), status: ($status), old_status: ($old_status), user_id: ($user_id)<BR>", "page_status" );

 
 
 if ( ! $noUserMessage && 4 == $old_status ) {
 
 if (6 == $status) {
 msg(i18n("Publishing of page <pageid {0}> at {1} has been approved.", 0, $page_id, db2date($time_pub, i18n("LOCALIZED_DATETIMEFORMAT"))), $editor, $USER_ID);
 }
 
 if (1 == $status) {
 msg(i18n("The page <pageid {0}> has been published.", 0, $page_id), $editor, $USER_ID);
 }
 
 if (0 == $status) {
 msg(i18n("The page <pageid {0}> has been taken into revision.", 0, $page_id), $editor, $USER_ID);
 }
 }

 
 if ( $old_pdate == 0 && $status == 1)
 $isNotification = true;

 if (!$DEBUG["dirt_dryrun"]) {

 
 if ( $isNotification && ( $status==1 || $status==4)) {
 $sql = "SELECT count(*) c FROM logcmd WHERE cmd_desc_id=".sqlf_tl_num(W_NOTIFY)." AND o_type=".sqlf_tl_num(T_PAGE)." AND o_id=".sqlf_tl_num($page_id)." AND timestamp > ".sqlf_tl_num((int)$old_pdate);
 $nrs = query($sql);
 if ( $nrs["arr"][0]["c"] == 0 ) {
 if ( $old_pdate==0 ) $notifyreason = "first publish";
 else $notifyreason = "user";
 decho( "Notification triggered: page($page_id) folder($folder_id) reason($notifyreason)", "pubnotify" );
 logcmd(W_NOTIFY,$T_PAGE,$page_id,$folder_id);
 }
 }

 
 
 if ($status == 1 && $user_id) {

 $sql = "UPDATE page SET publisher = ".sqlf_tl_num($user_id).", pdate = ".sqlf_tl_num($TIME).", status = ".sqlf_tl_num($status).", delay_publish = 0, ddate = ".sqlf_tl_num($TIME)." WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 if ($old_status != 2) {
 
 node_class("cnpageobject");
 $pageobject = new CNPageObject($page_id);
 $pageobject->createVersion($TIME, $user_id, false, true);
 }

 
 logcmd($W_PAGEPUB,$T_PAGE,$page_id,$folder_id);
 if ($old_status == 3 || $old_status == 5) {
 
 triggerEvent(T_FOLDER, $folder_id, EVENT_UPDATE, new EventObject(null, "pages"));
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject(null, "online"));
 } else {
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());
 }

 if ($FEATURE["cn_notification"]) cn_notify($page_id,$T_PAGE,$name,$folder_id,$T_FOLDER, $folderinfo["name"]);
 
 
 } else if ($status == 1) {

 $sql = "UPDATE page SET pdate = ".sqlf_tl_num($TIME).", status = ".sqlf_tl_num($status).", delay_publish = 0, ddate = ".sqlf_tl_num($TIME)." WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 if ($old_status != 2) {
 
 node_class("cnpageobject");
 $pageobject = new CNPageObject($page_id);
 $pageobject->createVersion($TIME, 1, false, true);
 }

 
 logcmd($W_PAGEPUB,$T_PAGE,$page_id,$folder_id);
 if ($old_status == 3 || $old_status == 5) {
 
 triggerEvent(T_FOLDER, $folder_id, EVENT_UPDATE, new EventObject(null, "pages"));
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject(null, "online"));
 } else {
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());
 }

 if ($FEATURE["cn_notification"]) cn_notify($page_id,$T_PAGE,$name,$folder_id,$T_FOLDER, $folderinfo["name"]);
 }

 
 else if ($status == 3) {
 
 if(!$FEATURE['javaparser']) {
 
 $sql = "UPDATE publish SET active = 0 WHERE page_id = ".sqlf_tl_num($page_id);
 query($sql);
 }

 if ($old_status != 3) {
 
 $sql = "SELECT count(id) AS c FROM publish WHERE page_id = ".sqlf_tl_num($page_id)." AND active = 1";
 $rs = query($sql,true);

 if ($old_status == 1 || $old_status == 2 || $rs["arr"][0]["c"] > 0) {
 $notified = msg_invalid_link($page_id, $editor, $USER_ID, "status3");
 }
 }

 $sql = "UPDATE page SET status = ".sqlf_tl_num($status).", delay_publish = 0 WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 
 logcmd(W_PAGEOFFLINE, T_PAGE, $page_id, $folder_id,"page_status: status($status) old status($old_status)");
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());
 triggerEvent(T_FOLDER, $folder_id, EVENT_UPDATE, new EventObject(null, "pages"));

 }

 else if ($status == 0 && $USER_ID != 1) {
 
 if ($old_status != 0 || $editor != $USER_ID) logcmd($W_EDIT,$T_PAGE,$page_id,$folder_id,"page_status: status($status) old status($old_status)");

 $sql = "UPDATE page SET editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", status = ".sqlf_tl_num($status).", delay_publish = 0 WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());
 }

 else if ($status == 4) {

 if ($user_id > 0) {
 logcmd($W_PAGEQUEUE, $T_PAGE,$page_id,$folder_id,"page_status: status($status) old status($old_status)");
 }

 $sql = "UPDATE page SET status = ".sqlf_tl_num($status).", delay_publish = 0 WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());
 }

 else if ($status == 5) {
 if(!$FEATURE['javaparser']) {
 
 $sql = "UPDATE publish SET active = 0 WHERE page_id = ".sqlf_tl_num($page_id);
 query($sql);
 }

 $sql = "UPDATE page SET status = ".sqlf_tl_num($status).", delay_publish = 0 WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 
 logcmd($W_PAGETIME, $T_PAGE,$page_id,$folder_id,"page_status: status($status) old status($old_status)");
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());

 } else {
 $sql = "UPDATE page SET status = ".sqlf_tl_num($status).", delay_publish = 0 WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 
 triggerEvent(T_PAGE, $page_id, EVENT_CN_PAGESTATUS, new EventObject());
 }

 } else {
 decho( "pagestatus has NOT been changed.", "dirt_dryrun" );
 }
 

 
 if ($old_status != $status) {
 $params = array("page_id"=>$page_id,"status"=>$status, "old_status"=>$old_status, "active"=>$active, "brokenlink_notified"=>$notified);
 if ($FEATURE["workflow"]) trigger_event("onpagestatus", $params);
 }
}

function get_page_stat($page_id) {
 if (!$page_id) halt(7,"get_page_status: invalid page_id($page_id)");
 $sql = "SELECT status, pdate FROM page WHERE id = ".sqlf_tl_num($page_id);
 $rs = query($sql,true);
 $status = $rs["arr"][0]["status"];
 $pdate = $rs["arr"][0]["pdate"];
 
 
 return $status;
}







function page_lang_exists($page_id, $contentgroup_id) {
 $rs = query("SELECT p1.id FROM page p INNER JOIN page p1 ON p.contentset_id = p1.contentset_id WHERE p.id = ".sqlf_tl_num($page_id)." AND p1.contentgroup_id = ".sqlf_tl_num($contentgroup_id));
 if ($rs["num"] == 0) {
 return false;
 }
 return true;
}













function set_page_status_after_edit($page_id) {
 global $TIME, $USER_ID, $FEATURE;
 $pageinfo = get_pageinfo($page_id);
 $hasChanged = true;
 if ($pageinfo["status"] != 0 || $pageinfo["edate"] < $TIME) {
 if ($FEATURE["contentversion2"] && $FEATURE["tuning_pagesave"]) {
 node_class("cnpageobject");
 $pageobject = new CNPageObject($page_id);
 $differs = $pageobject->diffVersion($TIME, $USER_ID);
 decho("<br>" . __FUNCTION__ . " with tuning_pagesave: diff: "
 . ($differs ? "TRUE" : "FALSE") . "<br>",
 "page_status");
 $pagestatus = $pageobject->getProperty('status');
 
 if ($pagestatus->d_string == 3 && $differs) {
 
 page_status($page_id, 0);
 
 $status = 3;
 } else {
 $status = 0;
 }
 if ($differs) {
 page_status($page_id, $status);
 } else {
 $hasChanged = false;
 }
 } else {
 page_status($page_id, 0);
 }
 }
 return $hasChanged;
}




function getPageByTagId($tag_type, $tag_id, $value_id = false) {

 $pages = array();

 $sqlpart = translate_tagtype($tag_type);
 
 if ($sqlpart != "contenttag") halt(101, "getPageByTagId: Invalid tag_type ($tag_type).");
 
 if (!$value_id) {
 $join = "";
 $where = "contenttag.id = ".sqlf_tl_num($tag_id);
 } else {
 $join = ", value";
 $where = "contenttag.id = value.contenttag_id AND value.id = ".sqlf_tl_num($value_id);
 }
 
 $sql = "SELECT page.id FROM page, contenttag $join WHERE page.content_id = contenttag.content_id AND $where";
 $rs = query($sql,1);
 
 foreach ($rs["arr"] as $val) {
 $pages[] = $val["id"];
 }
 
 return $pages;
}

$PAGE_STATUS_ICON[0] = $ICO_PAGE_HI;
$PAGE_STATUS_ICON[1] = $ICO_PAGE;
$PAGE_STATUS_ICON[2] = $ICO_PAGE;
$PAGE_STATUS_ICON[3] = $ICO_PAGE_OFF;
$PAGE_STATUS_ICON[4] = $ICO_PAGE_QUEUE;
$PAGE_STATUS_ICON[5] = $ICO_PAGE_TIME;


$PAGE_STATUS[0]=$DIC[798];

$PAGE_STATUS[1]=$DIC[799];

$PAGE_STATUS[2]=$DIC[799];

$PAGE_STATUS[3]=$DIC[800];

$PAGE_STATUS[4]=$DIC[801];

$PAGE_STATUS[5]=$DIC[848];

?>
