<?













$bundle = &NodeFactory::getStaticInstanceOf( T_BUNDLE, $bundle_id );
if( !$bundle->initFromID() ) {
 echo "ERROR No bundle found with id $bundle_id";
 exit();
}



if( $cmd == 'status' ) {
 $s = $bundle->getStatusMessage();
 $ttype = $bundle->getFieldValue('isimported') ? T_BUNDLE_IMPORT_ELEMENT : T_BUNDLE_EXPORT_ELEMENT;
 if( perm ($USER_ID, $ttype, $bundle_id, 0) ) {
 echo $s['status']."\n";
 } else {
 echo $DIC[2582];
 }
 exit();
}

if ($cmd == 'updatezip') {
 node_class('bundlebuild');
 if( perm ($USER_ID, T_BUNDLE, '', 6) || perm( $USER_ID, T_BUNDLE_IMPORT_ELEMENT, $bundle_id, 2) ) {
 
 if ($url == '' || $conflictbehavior == '') {
 exit('ERROR you must provide parameters {url} and {conflictbehavior}');
 }
 $tmpfilename = tempnam('/Node/tmp/', 'import_mgmt_');
 
 $contents = file_get_contents( $url );
 $fp = fopen($tmpfilename, 'w');
 fputs($fp, $contents);
 fclose($fp);
 
 $bundle = &BundleBuild::parseBundleMetaInfoFromZipFile($tmpfilename); 
 
 $cmpbundle = &Bundle::getImportBundleByGlobalId( $bundle->getFieldValue('globalprefix'), $bundle->getFieldValue('globalid') );
 if ($cmpbundle == null) {
 $cmpbundle = new Bundle();
 $bundle->copyFieldValues($cmpbundle);
 $cmpbundle->setFieldValue('isimported', 1);
 $cmpbundle->save();
 }
 
 
 $build = &$bundle->_builds[0];

 $date = $build->getFieldValue('date');

 $cmpbuild = $cmpbundle->getBuildByDate( $date );
 if ($cmpbuild != null) {
 echo "ERROR this exportfile has already been imported";
 exit();
 }
 
 $newfilename = BundleBuild::getBundleFileNameForDate( $date );
 rename( $tmpfilename, BundleBuild::getBundlePath() . $newfilename );
 $build->setFieldValue('filename', $newfilename);

 $savebuild = new BundleBuild();
 $build->copyFieldValues($savebuild);
 $savebuild->setFieldValue('bundle_id', $cmpbundle->getID());
 $savebuild->save();
 
 if(!perm($USER_ID, T_BUNDLE, '', 3) && !perm($USER_ID, T_BUNDLE_IMPORT_ELEMENT, $bundle_id, 1) ) {
 $conflictbehavior = "abort";
 }
 
 $latestimport = &$bundle->getLatestBundleImport();
 $group_id = -1;
 if ($latestimport) {
 $group_id = $latestimport->getFieldValue("group_id");
 }
 $import = &$savebuild->createNewImport(false, $group_id);
 $import->startImport(false, $conflictbehavior);
 $s = $savebuild->getStatusMessage();
 echo $s['status']."\n";
 } else {
 echo $DIC[2582];
 }
 
}


if( $cmd == 'createbuild' ) {
 node_class('bundlebuild');
 if( perm ($USER_ID, T_BUNDLE, '', 5) || perm( $USER_ID, T_BUNDLE_EXPORT_ELEMENT, $bundle_id, 2) ) {
 $latest =& $bundle->getLatestBuild();
 if ($latest) {
 $build =& $latest->createCopy();
 $build->setFieldValue('date', time());
 $build->setFieldValue('changelog', $changelog);
 $build->save();

 $build->startExport();
 $s = $build->getStatusMessage();
 echo $s['status']."\n";
 } else {
 echo "ERROR no build found for bundle $bundle_id.";
 }

 } else {
 echo $DIC[2582];
 }
 exit();
}

if( $cmd == 'update' ) {
 $build = &$bundle->checkForUpdates();
 if( perm ($USER_ID, T_BUNDLE, '', 6) || perm( $USER_ID, T_BUNDLE_IMPORT_ELEMENT, $bundle_id, 2) ) { 
 if($build !== false) {
 $build->downloadFile();
 $build->save();
 
 $latestimport = &$bundle->getLatestBundleImport();
 $group_id = -1;
 if ($latestimport) {
 $group_id = $latestimport->getFieldValue("group_id");
 }
 $import = &$build->createNewImport(true, $group_id);
 if(!perm($USER_ID, T_BUNDLE, '', 3) || !perm($USER_ID, T_BUNDLE_IMPORT_ELEMENT, $bundle_id, 1) ) { 
 $conflictbehavior = "abort";
 } 
 $import->startImport(false, $conflictbehavior);
 $s = $build->getStatusMessage();
 echo $s['status']."\n";
 } else {
 echo "NO UPDATE FOUND\n";
 }
 } else {
 echo $DIC[2582];
 }
 
 
 exit();
}

if( $cmd == 'restart' ) {
 
 $import = &$bundle->getLatestBundleImport();
 $import->startImport(false, 'overwrite');
 echo "Done.";
 exit();
}

exit();

?>
