<?php 
node_class( "sqltable" );
if ( $id && !$f_gentics_submitted ) 
{
 $sTable = new SqlTable( "job" );
 $jobs = $sTable->findBy( "id", $id );
 $job = $jobs[0];
 $name = $job->getValue( "name" );
 $descr = $job->getValue( "description" );
 $thetask = $job->getValue( "task_id" );
 $scheduleType = $job->getValue( "schedule_type" );
 $parallel = $job->getValue( "parallel" );
 $f_scheduleType = $scheduleType;
 $scheduleTypeClasses[$scheduleType]->loadData( node_unserialize( $job->getValue("schedule_data") ) );
 $scheduleTypeClasses[$scheduleType]->setGlobals();
 $failedemails = $job->getValue( "failedemails" );
}

if ( $f_id ) $id = $f_id;

if ( $id )
 load_menu( 872, $T_JOB, $id, $DIC[47] );
else
 load_menu( 872, $T_JOB, 0, $DIC[16] );

$f = $HI["text"];
$f["label"] = $DIC[1466];
$f["optional"] = true;
$f["var"] = "name";
$hi[] = $f;

$f = $HI["ta"];
$f["label"] = $DIC[1465];
$f["var"] = "descr";
$f["cols"] = 40;
$f["rows"] = 5;
$hi[] = $f;

$f = $HI["sel"];
$f["label"] = $DIC[1463];
$f["var"] = "thetask";
$tasklist = &$f["list"];
$hi[] = $f;

$f = $HI["checkbox"];
$f["var"] = "parallel";
$f["label"] = i18n("Can run Parallel");
$f["help"] = i18n("Can run at the same time as other tasks.");
$hi[] = $f;


$f = $HI["sel"];
$f["label"] = $DIC[1467];
$f["var"] = "scheduleType";
$f["onchange"] = "&1=1";
$f["force"] = false;
$f["nocheck"] = true;
$scheduleTypes = &$f["list"];
$hi[] = $f;

$scheduleTypes = array();
foreach ( $scheduleTypeClasses as $key=>$class )
{
 $scheduleTypes[$key] = $class->getName();
}


$hadd = null;
if ( $f_scheduleType )
 $hadd = $scheduleTypeClasses[$f_scheduleType]->buildForm( $id );
else
{
 reset( $scheduleTypeClasses );
 $hadd = $scheduleTypeClasses[key($scheduleTypeClasses)]->buildForm( $id );
}

if ( $hadd != NULL )
 $hi = array_merge( $hi, $hadd );



$f = $HI["text"];
$f["var"] = "failedemails";
$f["label"] = i18n( "Email on Failures" );
$f["help"] = i18n( "Enter email addresses (comma separated) which will receive an email notification if this task fails." );
$f["optional"] = true;
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "id";
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "origType";
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "origData";
$hi[] = $f;

if ( perm( $USER_ID, T_TASKADMIN, "", 13) ) $hi[] = $HI["ok"];
$hi[] = $HI["cancel"];

$f = new htmlform( $hi );


if ($faction == "cancel") 
{
 $REDO = 870;
} 
else if ($faction == "ok") 
{
 $REDO = 870; 
 
 $sTable = new SqlTable( "job" );
 if ( $id )
 {
 $jobs = $sTable->findBy( "id", $id );
 $job = $jobs[0];
 }
 else
 {
 $job = new SqlTableRow( $sTable );
 
 $job->setValue( "cdate", time() );
 $job->setValue( "creator", $USER_ID );
 }
 
 $job->setValue( "name", $name );
 $job->setValue( "description", $descr );
 $job->setValue( "task_id", $thetask );
 $job->setValue( "schedule_type", $scheduleType );
 $scheduleTypeClasses[$scheduleType]->loadGlobals();
 $job->setValue( "schedule_data", node_serialize($scheduleTypeClasses[$scheduleType]->getData()) );
 $job->setValue( "edate", time() );
 $job->setValue( "editor", $USER_ID );
 $job->setValue( "parallel", $parallel?1:0 );
 $job->setValue( "failedemails", $failedemails );
 $job->save();

 if ( $id ) {
 $jid = $id;

 
 
 logcmd(W_EDIT, T_JOB, $jid, 0, $name);
 } else {
 $jid = $job->getInsertId();

 logcmd(W_CREATE, T_JOB, $jid, 0, $name);
 }

 node_include( "cmd_tasks" );
 $deps = $scheduleTypeClasses[$scheduleType]->getRelations();
 cmd_update_job_dependencies( $jid, $deps );
} 
else 
{
 $tasklist = array();
 $tTable = new SqlTable( "task" );
 $tasks = $tTable->findAll( );
 foreach ( $tasks as $task )
 {
 $tasklist[$task->getValue("id")] = $task->getValue("name");
 }
}

?>
