<?php






$sql = <<<ENDSQL
ALTER TABLE contentmap ADD quick_created datetime default NULL;
ALTER TABLE contentmap ADD INDEX (quick_created);
UPDATE contentmap m SET quick_created = (SELECT value_date FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'created' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_created' WHERE name = 'created';

ALTER TABLE contentmap ADD quick_deadline datetime default NULL;
ALTER TABLE contentmap ADD INDEX (quick_deadline);
UPDATE contentmap m SET quick_deadline = (SELECT value_date FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'deadline' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_deadline' WHERE name = 'deadline';

ALTER TABLE contentmap ADD quick_subject mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_subject (255));
UPDATE contentmap m SET quick_subject = (SELECT value_text FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'subject' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_subject' WHERE name = 'subject';

ALTER TABLE contentmap ADD quick_type mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_type (255));
UPDATE contentmap m SET quick_type = (SELECT value_text FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'type' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_type' WHERE name = 'type';

ALTER TABLE contentmap ADD quick_status mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_status (255));
UPDATE contentmap m SET quick_status = (SELECT value_text FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'status' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_status' WHERE name = 'status';

ALTER TABLE contentmap ADD quick_description mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_description (255));
UPDATE contentmap m SET quick_description = (SELECT value_clob FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'description' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_description' WHERE name = 'description';
ENDSQL;


query("USE nodecontentrepository");


$queries = explode("\n", $sql);
while (list($k, $stmt) = each($queries)) {
 if (trim($stmt) != "") {
 query($stmt);
 }
}
?>