	<link rel="stylesheet" href="<?= $PORTLETAPP_PREFIX ?><?= $BUILD_ROOT_TIMESTAMP ?>/alohaeditor-0.10/css/aloha.css" id="aloha-style-include" type="text/css">
	
	<style type="text/css">
	<!--
	html, body, div, span, object, iframe,
	h1, h2, h3, h4, h5, h6, p, blockquote, pre,
	abbr, address, cite, code, del, dfn, em, img, ins, kbd, q, samp,
	small, strong, sub, sup, var, b, i, dl, dt, dd, ol, ul, li,
	fieldset, form, label, legend,
	table, caption, tbody, tfoot, thead, tr, th, td,
	article, aside, canvas, details, figcaption, figure,
	footer, header, hgroup, menu, nav, section, summary,
	time, mark, audio, video {
	  margin: 0;
	  padding: 0;
	  border: 0;
	  font-size: 100%;
	  font: inherit;
	  vertical-align: baseline;
	}
	
	html, body {
		font-family: Georgia, serif;
		color: #555555;
		height: 100%;
	}
	
	body {
		text-align: center;
		font-size: 1.05em;
		line-height: 1.5em;
	}
	
 	/* Message */
 	
 	#message-spacer {
 		height: 30px;
 		width: 100%;
 	}
 	 
 	#message-container {
 	    font-family: Arial, Verdana;
 	    font-size: 0.7em; 
		margin-left: auto;
		margin-right: auto; 
 	    position: relative; 
 	    background: #fffcdf;
 	    z-index: 99999; 
 	    width: 500px; 
 	    border-radius: 3px;
 	    -moz-border-radius: 3px;
 	    -mwebkit-border-radius: 3px;
 	    -moz-box-shadow: 0 0 3px #ffe979;
 	    -webkit-box-shadow: 0 0 3px #ffe979; 
 	    box-shadow: 0 0 3px #ffe979; 
 	    border: solid 1px #ffe979; 
 	}
	
 	#message-container .warning {
 	    -moz-box-shadow: 0 0 3px #f7a137;
 	    -webkit-box-shadow: 0 0 3px #f7a137;
 	    box-shadow: 0 0 3px #f7a137;
 	    border: solid 1px #f7a137;
 	}
	
 	.loading #message-image { 
 		background-image: url(../img/loading1.gif);
 		background-repeat: no-repeat; 
 		margin-left: auto;
		margin-right: auto;
	    position: relative;
 	    height: 18px;
 		background-position-x: 67px;
 	}
	
	.warning {
 		background-color: #fee5b7 !important;
	}
		
 	.warning #message-image {
 		background-image: url(../img/warning.gif);
 		background-repeat: no-repeat;
 		margin-left: auto;
 		margin-right: auto;
 	    position: relative;
 	    height: 18px;
 		background-position-x: 117px; 
 	} 
	
	/* Aloha container for floating menu */
	#alohaContainer {
		margin-bottom: 10px;
		height: 60px;
	}
	
	#image-actions {
	    margin-left: auto;
	    margin-right: auto;
	    position: relative;
	    top: 15px;
		width: 344px;
	    padding-bottom: 4px;
	    padding-top: 11px;
	}
	
	/* Image Area */
	#imageArea {
		margin-top: 10px;
	}

 	-->
	</style>
	<div id="message-spacer">
		<div id="message-container">
			<span><?= i18n('image-loading') ?></span>
			<div id="message-image"></div>
		</div>
	</div>
	<div id="imageArea">
		<div id="alohaContainer"></div>
		<div id="imageContainer" contenteditable="false">
			<img class="global" src="<?= $STAG_PREFIX ?>?sid=<?= $SID ?>&do=16000&id=<?= $_GET['id']?>&keepsid=1&time=<?= time() ?>"></img>
			<div id="image-actions" contenteditable="false">
				<a id="save-action" href="#"><img src="?do=15&text=<?= i18n('Ok') ?>"></a>
				<a id="copy-action" href="#"><img src="?do=15&text=<?= i18n('duplicate-image') ?>"></a>
				<a id="cancel-action" href="#"><img src="?do=15&text=<?= i18n('Cancel') ?>"></a>
			</div>
		</div>

	</div>
	
	
		
	<div id="panelLeftPropertiesContainer" style="display: none">
		<form onsubmit="return false;">
		<div class="panelContent">
		<p><label for="filename"><?= i18n('Filename') ?>:</label><br /><input id="filename" type="text" value=""/>.<span id="extension"></span></p>
		<p><label for="description"><?= i18n('Description') ?>:</label><br /><textarea id="description" cols="19" rows="4" type="text" value=""></textarea></p>
		</div> 
		</form>
	</div>	
	<?php 
 
 $locale = $LANGUAGE == 1 ? "de" : "en"; 
 ?>
	<script type="text/javascript">
		window.SID = <?= $SID ?>;
		window.BACKURL = "?sid=<?= $SID ?>&do=13020&NODE_ID=<?= $NODE_ID ?>&FOLDER_ID=<?= $FOLDER_ID ?>";
		window.PORTLETAPP_PREFIX = "<?= $PORTLETAPP_PREFIX ?>";
		
		(function(window, undefined) {
			
			if (window.Aloha === undefined || window.Aloha === null) {
				var Aloha = window.Aloha = {};		
			}

			window.require = {
				locale: '<?= $locale ?>'	
			};
			
			window.Aloha.settings = {
				
						logLevels: {'error': true, 'warn': true, 'info': true, 'debug': false},
						errorhandling : false,
						ribbon: false,
						
						locale: '<?= $locale ?>',
						
						"floatingmenu": {
							draggable: false
						},
						"plugins": {
							"image": {
								'onResize': function() {},
								'globalselector': '.global',
								'maxWidth':  <?= $ALOHA_SETTINGS['plugins']['image']['maxWidth'] ?>,
								'minWidth':  <?= $ALOHA_SETTINGS['plugins']['image']['minWidth'] ?>,
								'maxHeight': <?= $ALOHA_SETTINGS['plugins']['image']['maxHeight'] ?>,
								'minHeight': <?= $ALOHA_SETTINGS['plugins']['image']['minHeight'] ?>,
								'fixedAspectRatio': <?= $ALOHA_SETTINGS['plugins']['image']['fixedAspectRatio'] ?>,
								'ui': {
									'oneTab': true,
									'insert': false,
									'margin': false,
									'meta': false,
									'align': false
								}
							}
									
						}
				};
							
		})(window);
	</script>

	<script src="<?= $PORTLETAPP_PREFIX ?><?= $BUILD_ROOT_TIMESTAMP?>/alohaeditor-0.10/lib/aloha.js" data-aloha-plugins="common/image,gcn/gcn-image,gcn/imagemanipulation2"></script>