<?

mysession_var_reg("warn_too_many_results");
mysession_var_reg("administrate");
mysession_var_reg("portalid");

Guifactory::setMainGui("main");

if ( !isset($MEMBERS_BASE) )
 $MEMBERS_BASE = array( $portalid );

node_class( "resultsetformatter" );
node_class( "dateformatter" );

class MailFormatter extends ResultsetFormatter
{
 function format( $row )
 {
 global $STAG, $lang;
 
 if ( $row["email"] )
 return "<a href=\"mailto:".$row["email"]."\">".$row["email"]."</a>";
 return "";
 }
}

class NameFormatter extends ResultsetFormatter
{
 function format( $row )
 {
 global $STAG, $lang;
 

 
 if ( !trim($row["name"]) )
 {
 $row["name"] = "<i>$lang[2700]</i>";
 }
 return "<a href=\"$STAG&do=72010&uid=".$row["id"]."\">".$row["name"]."</a>";
 }
}


$select = "userid as id, email, company, create_time, level, concat(firstname, ' ', lastname) as name ";
$from = $table["system_user"];
$where = "portalid in (" . implode( ", ", $MEMBERS_BASE ) . ")";

$ds = new SQLDatasource( "sql_members_user_list", $select, $from, $where );
$ds->setDBHandle( $PDB );
$ds->addColumn( "id" , $lang[2001], true, "userid", "userid" );
$ds->addColumn( "fname" , $lang[2002], false, "lastname", "lastname" ); 
$ds->addColumn( "femail" , $lang[2050], true, "email", "email" ); 
$ds->addColumn( "company" , $lang[2060], true, true, true ); 
$ds->addColumn( "fcreate_time",$lang[5032], true, false, "create_time" );
$ds->addColumn( "level" , $lang[2015], true, false, true ); 
$ds->addFormatter( "fname", new NameFormatter() );
$ds->addFormatter( "femail", new MailFormatter() );
$ds->addFormatter( "fcreate_time", new DateFormatter("create_time") );
$ds->addSearchableColumn( "country" );
$ds->addSearchableColumn( "lastname" );
$ds->addSearchableColumn( "firstname" );
$ds->addSearchableColumn( "login" );
$ds->addSearchableColumn( "description" );
$ds->addSearchableColumn( "company" );
$ds->addSearchableColumn( "email" );



$ds->setDefaultSort( "create_time", "DESC" );
$ds->addAction( new SQLDeleteAction( "$STAG_PREFIX?do=11&module=system&img=delete.gif", $T_MEMBERS, "Delete", $table["system_user"], 
 "userid", 0, "members_user_list.php", null, $PDB ) );
$ds->addAction( new SQLDeleteAction( null, 0, "Delete", $table["newsletter_subscribe"], 
 "userid", 0, "", null, $PDB ) );




$test_list = new ItemList3( "members_user_list", $ds );
$test_list->setShowInfo( true );

adv_ass_search(72000, '', true);
load_menu(72100, $T_MEMBERS, 0);

?>
