<?

$maingui = &GUIFactory::setMainGUI( "main" );

mysession_var_reg("BUNDLE_ISIMPORT");
mysession_var_reg("BUNDLE_BUILD_ID");
$BUNDLE_BUILD_ID = "";

function checkUpdates(&$form, $param) {
 global $USER_ID;
 
 
 $sql = "SELECT id AS bundleid FROM bundle WHERE isimported=1";
 $rs = query( $sql );
 $globalPerm = perm( $USER_ID, T_BUNDLE, '', 6);
 foreach ($rs["arr"] as $row) {
 if($globalPerm || perm( $USER_ID, T_BUNDLE_IMPORT_ELEMENT, $row["bundleid"], 2)) {
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $row["bundleid"]);
 $bundle->checkForUpdates();
 }
 }
}

function checkSingleUpdate( $id ) {
 global $USER_ID;
 if (perm( $USER_ID, T_BUNDLE, '', 6) || perm( $USER_ID, T_BUNDLE_IMPORT_ELEMENT, $id, 2)) {
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $id);
 $bundle->checkForUpdates();
 }
}

if( $type ) {
 $BUNDLE_ISIMPORT = ($type == 'import');
}
$isimport = $BUNDLE_ISIMPORT;

if(!perm($USER_ID, T_BUNDLE, '', 0)) {
 $ERROR = $DIC[2582];
 return;
}

$ASSCORE = i18n($isimport ? "import_asscore" : "export_asscore");
load_menu(1012, T_BUNDLE, '', '', 0, array( 'isimport'=>$isimport, 'islist' => true ));

$form = new HtmlForm3( 'bundle_list' );
$isNew = $form->isNew();

if ($cmd == "startdryrun") {
 $bundlebuild = &NodeFactory::getStaticInstanceOf(T_BUNDLE_BUILD, $bundlebuild_id);
 $bundle = &$bundlebuild->getBundle();
 $updateUrl = $bundle->getUpdateUrl();
 $updateBuild = &Bundle::getLatestBuildFromUpdate($updateUrl);
 if ($updateBuild->getFieldValue('date') == $bundlebuild->getFieldValue('date')) {
 
 $updateBuild->downloadFile();
 $bundlebuild->setFieldValue('filename', $updateBuild->getBundleFileName());
 $bundlebuild->save();

 
 $group_id = $bundle->getFieldValue("importgroup_id");

 $bundlebuild->createNewImport(true, $group_id);
 } else {
 
 }
}

if ($cmd == "cancel") {
 global $USER_ID;
 if ($type == "import") {
 if (perm( $USER_ID, T_BUNDLE_IMPORT_ELEMENT, $bundleid, 2 ) || perm( $USER_ID, T_BUNDLE, '', 6 )) {
 $bundleimport = &NodeFactory::getStaticInstanceOf(T_BUNDLE_IMPORT, $bundleimportid);
 $bundleimport->cancelImport();
 }
 } else if ($type == "export") {
 if (perm( $USER_ID, T_BUNDLE_EXPORT_ELEMENT, $bundleid, 2 ) || perm( $USER_ID, T_BUNDLE, '', 5 )) {
 $bundlebuild = &NodeFactory::getStaticInstanceOf(T_BUNDLE_BUILD, $bundlebuildid);
 $bundlebuild->cancelExport();
 }
 }
}

function checkreload($status) {
 global $maingui;
 if( strpos($status['status'], 'QUEUED') === 0 || strpos($status['status'], 'INPROGRESS') === 0 ) {
 $maingui->setUpdateInterval( 10 );
 addRefreshButton(true);
 } else {
 addRefreshButton(false);
 }
}

$showRefreshButton = false;
function addRefreshButton($visible) {
 global $form, $showRefreshButton;
 $showRefreshButton |= $visible;
 if ($showRefreshButton) {
 $form->addButton( 'refresh', new Button(i18n('Reload')), new SimpleFormAction(), true);
 } else {
 $form->removeButton( 'refresh' );
 }
}


function bundle_startimport( $id ) {
 global $USER_ID;
 
 $bundle = &NodeFactory::getStaticInstanceOf( T_BUNDLE, $id );
 $bundleimport = &$bundle->getCurrentBundleImport();
 $bundleimport->startImport();
}

function bundle_delete( $id ) {
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $id);
 $bundle->delete();
}

function bundle_copy( $id ) {
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $id);
 $bundle->createCopy();
}

if( $isNew ) {
 node_class("listcomponent");
 node_class("textcomponent");
 node_class("itemlistcomponent");
 node_class("sqldatasource");
 node_class("commandaction");
 


 $main = new ListComponent();


 $dsn = new SQLDatasource( 'bundle_list_sql', 'id,name,isimported,description,updateurl', 'bundle', 'isimported = ' . ($isimport ? '1' : '0') );
 $dsn->setDBHandle( $DB );
 $dsn->setSort( 'name' );
 $dsn->addFormatter( 'name', new NameEscapeFormatter() );
 $dsn->setSearchable( true );
 $dsn->setSQLDatasourceFilter( new BundlePermissionFilter() );
 $dsn->makeLink( 'lnkname', 'name', "do=1011&type=$type&tab=".($isimport ? 'main' : 'builds'), 'list', 'bundle_id', 'id' );

 
 if (perm($USER_ID, T_BUNDLE, '', 7) & !$isimport) {
 $dsn->addAction(new CommandAction($ICO_COPY, "copy", i18n("Copy"), "bundle_copy"));
 }

 if( perm( $USER_ID, T_BUNDLE, '', 4) & !$isimport) {
 $dsn->addAction(new CommandAction($ICO_DELETE, "delete", i18n("Delete"), "bundle_delete"));
 }

 if ($isimport) {
 $dsn->addColumn( 'del', '', true, false );
 $dsn->addFormatter( 'del', new SingleDeleteActionFormatter() );
 $dsn->addAction(new CommandAction($ICO_SEARCH, "checksingleupdate", i18n("Check for updates"), "checkSingleUpdate"));
 }
 
 $dsn->addColumn( 'lnkname', i18n('Name'), true, false, 'name' );
 $dsn->addSearchableColumn('name');
 if($isimport) {
 
 $dsn->addColumn('updateurl', i18n('Imported as'), true, false, true);
 $dsn->addColumn( 'installedversion', i18n( 'Installed Version' ), true, false );
 $dsn->addColumn( 'availableversion', i18n( 'Available Version' ), true, false );
 $dsn->addColumn( 'status', i18n( 'Status' ), true, false );
 $dsn->addFormatter( 'status', new ImportStatusFormatter() );
 $dsn->addFormatter( 'installedversion', new InstalledVersionFormatter() );
 $dsn->addFormatter( 'availableversion', new AvailableVersionFormatter() );
 $dsn->addFormatter('updateurl', new ImportTypeFormatter() );
 } else {
 
 $dsn->addColumn( 'status', i18n( 'Status'), true, false );
 $dsn->addFormatter( 'status', new StatusFormatter() );
 }

 if( $isimport ) {
 
 }

 $dsn->setAss( "<b>".i18n(!$isimport?'Export Bundle':'Import Bundle')."</b><br><br><b>".i18n('ID').":</b> \$id<br><b>$DIC[1466]:</b> \$name<br>".
 "<b>$DIC[305]:</b><br>\$description<br>");

 $list = new ItemList3("bundle_list_itemlist", $dsn );
 $listcomponent = new ItemListComponent( NULL, $list );
 $main->setComponent('bundlelist', $listcomponent );




 $form->addComponent( 'main', $main );
 if ($isimport) {
 global $ICO_BUNDLE_IMPORT;
 $form->setHeader( i18n('List of imports'), $ICO_BUNDLE_IMPORT );
 } else {
 global $ICO_BUNDLE_EXPORT;
 $form->setHeader( i18n('List of exports'), $ICO_BUNDLE_EXPORT );
 }








 
} else {
 $myitemlistcomp = & $form->resolveComponent( 'main.bundlelist' );
 $itemlist3 = & $myitemlistcomp->getList();
 $dsn = & $itemlist3->getDatasource();
 $dsn->setDBHandle( $DB );

}

$html = $form->getHTMLOutput();

?>
