<?php

GUIFactory::setMainGUI('main');
 
node_include( "task_schedule_func" );

$tid = $f_tid?$f_tid:$tid;
if ( !$tid )
 halt( 7, "task_template_params_edit.php: no or invalid template id ($tid) given!" );

$tplTable = new SqlTable( "tasktemplate" );
$templates = $tplTable->findBy( "id", $tid );
$template = $templates[0];
 
$paramTable = new SqlTable( "tasktemplateparam" );
$params = $paramTable->findBy( "tasktemplate_id", $tid );
$commandParams = bindCommandParams( $template->getValue("command"), $params );


if ( !count($commandParams) )
{
 $id = $tid;
 $REDO = $FROM;
 return;
}

$paramList = array(
 1=> $DIC[348],
 2=> $DIC[129],
 3=> $DIC[245],
 4=> i18n('Page')
);

foreach ( $commandParams as $key=>$value )
{
 $f = $HI["sel"];
 $f["label"] = "$key";
 $f["var"] = "$key";
 $f["list"] = $paramList;
 $hi[] = $f;
 
 if ( $value != NULL )
 $$key = $value->getValue( "paramtype" );
}

$f = $HI["hidden"];
$f["var"] = "tid";
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "deleteOnCancel";
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "FROM";
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "newTemplate";
$hi[] = $f;


$hi[] = $HI["ok"];
$hi[] = $HI["cancel"];

$f = new htmlform($hi,"templateparamsedit");


if ( $faction == "cancel" ) 
{
 $REDO = $FROM;
 if ( $newTemplate )
 $template->delete();
}
else if ( $faction == "ok" ) 
{
 $REDO = $FROM;
 $used = array();
 
 foreach ( $commandParams as $key=>$value )
 {
 if ( $value != NULL )
 {
 $used[$value->getValue("name")] = true;
 if ( $$key != $value->getValue( "paramtype" ) )
 {
 $value->setValue( "paramtype", $$key );
 $value->save();
 }
 }
 else
 {
 $p = new SqlTableRow( $paramTable );
 $p->setValue( "paramtype", $$key );
 $p->setValue( "tasktemplate_id", $tid );
 $p->setValue( "name", $key );
 $p->save();
 }
 }
 
 foreach ( $params as $param )
 {
 if ( !$used[$param->getValue("name")] ) {
 $paramid = $param->getValue("id");
 $param->delete();
 
 $sql = "DELETE FROM taskparam WHERE templateparam_id = '".sqlf_escaped($paramid)."'";
 query($sql);
 }
 }
 
 $params = $paramTable->findBy( "tasktemplate_id", $tid );
 $taskTable = new SqlTable( "task" );
 $taskparamTable = new SqlTable( "taskparam" );
 foreach ( $params as $param ) {
 $tasks = $taskTable->findBy( "tasktemplate_id", $tid );
 foreach ( $tasks as $task ) {
 
 $sql = "SELECT id FROM taskparam WHERE task_id = '".sqlf_escaped($task->getValue('id'))."' AND templateparam_id = '".sqlf_escaped($param->getValue('id'))."'";
 $rs = query( $sql );
 if( $rs['num'] == 0 ) {
 
 $selector = &initSelector( $param->getValue('paramtype') );
 $fields = array_keys($selector->getFields(true));
 foreach ( $fields as $field ) {
 $sql = "INSERT INTO taskparam (task_id, templateparam_id, name, value) values ('".sqlf_escaped($task->getValue('id'))."','".sqlf_escaped($param->getValue('id'))."','".sqlf_escaped($field)."','')";
 
 query( $sql );
 }
 }
 }
 }
 $id = $tid;
 $f->clear();
 unset( $hi );
}

?>
