<?

function get_objprops() {
 global $T_OBJPROP, $T_FOLDER, $T_PAGE, $T_IMAGE, $DIC, $T_FILE, $T_TEMPLATE, $FEATURE, $USER_ID;
 $rs = Array();
 $tmp = Array();
 if ( perm($USER_ID,$T_OBJPROP,$T_FOLDER,0) || !$FEATURE["objtag_perm"] ){
 $tmp["id"] = $T_FOLDER;
 $tmp["name"] = $DIC[402];
 $tmp["type"] = $T_OBJPROP;
 $rs[] = $tmp;
 }

 if ($FEATURE['template_objprop'] && ( perm($USER_ID,$T_OBJPROP,$T_TEMPLATE,0) || !$FEATURE["objtag_perm"] )) {
 $tmp["id"] = $T_TEMPLATE;
 $tmp["name"] = i18n("Templates");
 $tmp["type"] = $T_OBJPROP;
 $rs[] = $tmp;
 }

 if ( perm($USER_ID,$T_OBJPROP,$T_PAGE,0) || !$FEATURE["objtag_perm"] ){
 $tmp["id"] = $T_PAGE;
 $tmp["name"] = $DIC[1668];
 $tmp["type"] = $T_OBJPROP;
 $rs[] = $tmp;
 }

 if ( perm($USER_ID,$T_OBJPROP,$T_IMAGE,0) || !$FEATURE["objtag_perm"] ){
 $tmp["id"] = $T_IMAGE;
 $tmp["name"] = $DIC[381];
 $tmp["type"] = $T_OBJPROP;
 $rs[] = $tmp;
 }

 if ( perm($USER_ID,$T_OBJPROP,$T_FILE,0) || !$FEATURE["objtag_perm"] ){
 $tmp["id"] = $T_FILE;
 $tmp["name"] = i18n("Files");
 $tmp["type"] = $T_OBJPROP;
 $rs[] = $tmp;
 }
 return $rs;
}

function get_objpropelements($objprop) {
 global $T_OBJPROP, $FEATURE, $T_OBJPROPELEMENT, $USER_ID;
 $rs = Array();
 $sql = "SELECT objtag.id, objtag.name, objtag.construct_id, construct.icon, objtag.inpage, ".sqlf_tl_num($T_OBJPROPELEMENT)." as type,
	        LOWER(objtag.name) AS l_name
	        FROM objtag, construct
	        WHERE objtag.obj_type = ".sqlf_tl_num($objprop)." AND objtag.obj_id = 0 AND objtag.construct_id = construct.id ORDER BY l_name";
 $rs = query($sql);
 $ret = array();
 foreach ($rs['arr'] as $res) {
 if (perm($USER_ID, $T_OBJPROPELEMENT, $res['id'], 1)) {
 $ret[] = $res;
 }
 }
 return $ret;
}?>
